added $DPKG_OPTIONS to all instances of apt-get and aptitude (attempt 2) https:/...
[grml-debootstrap.git] / chroot-script
index a711641..bbc91f0 100755 (executable)
@@ -5,8 +5,9 @@
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
 ################################################################################
-
-set -e # exit on any error
+# GRML_CHROOT_SCRIPT_MARKER - do not remove this line unless you want to keep
+# this script as /bin/chroot-script on your new installed system
+################################################################################
 
 . /etc/debootstrap/config    || exit 1
 . /etc/debootstrap/variables || exit 1
@@ -17,11 +18,19 @@ set -e # exit on any error
 
 # use aptitude only if it's available
 if [ -x /usr/bin/aptitude ] ; then
-   APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
-   APTUPDATE='aptitude update'
+   APTUPDATE="aptitude update $DPKG_OPTIONS"
+   # Debian ISOs do not contain signed Release files
+   if [ -n "$ISO" ] ; then
+      APTINSTALL="aptitude -y --allow-untrusted --without-recommends install $DPKG_OPTIONS"
+      APTUPGRADE="aptitude -y --allow-untrusted safe-upgrade $DPKG_OPTIONS"
+   else
+      APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
+      APTUPGRADE="aptitude -y safe-upgrade $DPKG_OPTIONS"
+   fi
 else
-   APTINSTALL="apt-get --force-yes -y install $DPKG_OPTIONS"
-   APTUPDATE='apt-get update'
+   APTINSTALL="apt-get --force-yes -y --no-install-recommends install $DPKG_OPTIONS"
+   APTUPDATE="apt-get update $DPKG_OPTIONS"
+   APTUPGRADE="apt-get --force-yes -y upgrade $DPKG_OPTIONS"
 fi
 
 if [ -z "$STAGES" ] ; then
@@ -42,19 +51,70 @@ stage() {
   echo "   Executing stage ${1}"
   return 0
 }
+
+askpass() {
+  # read -s emulation for dash. result is in $resp.
+  set -o noglob
+  [ -t 0 ] && stty -echo
+  read resp
+  [ -t 0 ] && stty echo
+  set +o noglob
+}
 # }}}
 
 # define chroot mirror {{{
 chrootmirror() {
-  [ -n "$KEEP_SRC_LIST" ] && return
-  [ -z "$COMPONENTS" ]    && COMPONENTS='main contrib non-free'
+  if [ -n "$KEEP_SRC_LIST" ] ; then
+    echo "KEEP_SRC_LIST has been set, skipping chrootmirror stage."
+    return
+  fi
+
+  if [ -z "$COMPONENTS" ] ; then
+    COMPONENTS='main contrib non-free'
+  fi
+  echo "Using repository components $COMPONENTS"
 
   if [ -n "$ISO" ] ; then
-     echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
-     [ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || /bin/true
+    echo "Adjusting sources.list for ISO (${ISO})."
+    echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
+    echo "Adding mirror entry (${MIRROR}) to sources.list."
+    [ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || true
   else
     if [ -n "$MIRROR" ] ; then
-       echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
+      echo "Adjusting sources.list for mirror (${MIRROR})."
+      echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
+    fi
+  fi
+
+  # add security.debian.org:
+  case "$RELEASE" in
+    unstable|sid) ;;  # no security pool available
+    *)
+      echo "Adding security.debian.org to sources.list."
+      echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
+      ;;
+  esac
+}
+# }}}
+
+# remove local chroot mirror {{{
+remove_chrootmirror() {
+  if [ -n "$KEEP_SRC_LIST" ] ; then
+    echo "KEEP_SRC_LIST has been set, skipping remove_chrootmirror stage."
+    return
+  fi
+
+  if [ -n "$ISO" ] ; then
+    echo "Removing ISO (${ISO}) from sources.list."
+    TMP_ISO=$(echo "$ISO" |sed 's#/#\\/#g')
+    sed -i "/deb $TMP_ISO $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
+  else
+    if [ -n "$MIRROR" -a -n "$(echo $MIRROR|grep file:)" ] ; then
+      echo "Removing local mirror (${MIRROR}) from sources.list."
+      TMP_MIRROR=$(echo "$MIRROR" |sed 's#/#\\/#g')
+      sed -i "/deb $TMP_MIRROR $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
+      echo "Adding fallback mirror entry (${FALLBACK_MIRROR}) to sources.list instead."
+      echo "deb $FALLBACK_MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
     fi
   fi
 }
@@ -64,9 +124,8 @@ chrootmirror() {
 grmlrepos() {
   if [ -n "$GRMLREPOS" ] ; then
      # user might have provided their own apt sources.list
-     if ! grep -q grml /etc/apt/sources.list 2>/dev/null ; then
-        cat >> /etc/apt/sources.list << EOF
-
+     if ! grep -q grml /etc/apt/sources.list.d/grml.list 2>/dev/null ; then
+        cat >> /etc/apt/sources.list.d/grml.list << EOF
 # grml: stable repository:
   deb     http://deb.grml.org/ grml-stable  main
   deb-src http://deb.grml.org/ grml-stable  main
@@ -74,16 +133,20 @@ grmlrepos() {
 # grml: testing/development repository:
   deb     http://deb.grml.org/ grml-testing main
   deb-src http://deb.grml.org/ grml-testing main
-
 EOF
      fi
 
-     # make sure we have the keys available for aptitude
-     gpg --keyserver subkeys.pgp.net --recv-keys F61E2E7CECDEA787
-     gpg --export F61E2E7CECDEA787 | apt-key add - || /bin/true # not yet sure
-     # why it's necessary, sometimes we get an error even though it works [mika]
+     if apt-get update $DPKG_OPTIONS; then
+       apt-get -y --allow-unauthenticated install grml-debian-keyring $DPKG_OPTIONS
+       apt-get update $DPKG_OPTIONS
+     else
+       # make sure we have the keys available for aptitude
+       gpg --keyserver subkeys.pgp.net --recv-keys F61E2E7CECDEA787
+       gpg --export F61E2E7CECDEA787 | apt-key add - || true # not yet sure
+       # why it's necessary, sometimes we get an error even though it works [mika]
+     fi
 
-     # make sure we install packages from grml's pool only if not available
+     # make sure we install packages from Grml's pool only if not available
      # from Debian!
      if ! grep -q grml /etc/apt/preferences 2>/dev/null ; then
         cat >> /etc/apt/preferences << EOF
@@ -102,6 +165,32 @@ EOF
 }
 # }}}
 
+# check available backports release version {{{
+checkbackports() {
+  wget -q -O/dev/null http://backports.debian.org/debian-backports/dists/${1}-backports/Release
+}
+# }}}
+
+# feature to provide Debian backports repos {{{
+backportrepos() {
+    if [ -n "$BACKPORTREPOS" ] ; then
+        if ! checkbackports $RELEASE ; then
+            echo "Backports for ${RELEASE} are not available." >&2
+            exit 1
+        else
+            # user might have provided their own apt sources.list
+            if ! grep -q backports /etc/apt/sources.list.d/backports.list 2>/dev/null ; then
+                cat >> /etc/apt/sources.list.d/backports.list << EOF
+# debian backports: ${RELEASE}-backports repository:
+deb     http://backports.debian.org/debian-backports ${RELEASE}-backports main
+deb-src http://backports.debian.org/debian-backports ${RELEASE}-backports main
+EOF
+            fi
+        fi
+    fi
+}
+# }}}
+
 # set up kernel-img.conf {{{
 kernelimg_conf() {
   if ! [ -r /etc/kernel-img.conf ] ; then
@@ -116,15 +205,6 @@ EOF
 }
 # }}}
 
-# create default devices {{{
-makedev() {
-  if ! [ -r /dev/hda20 ] ; then
-     echo "Creating generic devices in /dev - this might take a while..."
-     cd /dev && MAKEDEV generic
-  fi
-}
-# }}}
-
 # make sure services do not start up {{{
 install_policy_rcd() {
   if ! [ -r /usr/sbin/policy-rc.d ] ; then
@@ -138,6 +218,29 @@ EOF
 }
 # }}}
 
+# make sure we have an up2date system {{{
+upgrade_system() {
+  if [ "$UPGRADE_SYSTEM" = "yes" ] ; then
+    echo "Running update + upgrade"
+    $APTUPDATE
+    $APTUPGRADE
+  else
+    echo "Not running update + upgrade as \$UPDATE_AND_UPGRADE is not set to 'yes'."
+  fi
+}
+
+# }}}
+# remove now useless apt cache {{{
+remove_apt_cache() {
+  if [ "$RM_APTCACHE" = 'yes' ] ; then
+    echo "Cleaning apt cache."
+    apt-get clean $DPKG_OPTIONS
+  else
+    echo "Not cleaning apt cache as \$RM_APTCACHE is unset."
+  fi
+}
+# }}}
+
 # install additional packages {{{
 packages() {
   # Pre-seed the debconf database with answers. Each question will be marked
@@ -149,7 +252,7 @@ packages() {
 
   if [ "$PACKAGES" = 'yes' ] ; then
      if ! [ -r /etc/debootstrap/packages ] ; then
-       echo "Error: /etc/debootstrap/packages not found, exiting."
+       echo "Error: /etc/debootstrap/packages (inside chroot) not found, exiting." >&2
        exit 1
      else
        $APTUPDATE
@@ -172,22 +275,50 @@ extrapackages() {
 }
 # }}}
 
-# install kernel packages {{{
-kernel() {
+# check if the specified Debian package exists
+package_exists() {
+  output=$(apt-cache show "$1" 2>/dev/null)
+  [ -n "$output" ]
+  return $?
+}
+
+
+# determine the kernel version postfix
+get_kernel_version() {
   # do not override $KERNEL if set via config file
-  if [ -z "$KERNEL" ] ; then
-     if [ "$ARCH" = 'i386' ] ; then
-        KERNEL='2.6-686'
-     elif [ "$ARCH" = 'amd64' ] ; then
-        KERNEL='2.6-amd64'
-     fi
+  if [ -n "$KERNEL" ] ; then
+    echo "$KERNEL"
+    return 0
   fi
 
-  if [ -n "$KERNEL" ] ; then
-     $APTUPDATE
+  case $ARCH in
+    i386)   KARCH=686   ;;
+    amd64)  KARCH=amd64 ;;
+    *)
+      echo "Only i386 and amd64 are currently supported" >&2
+      return 1
+  esac
+
+  for KPREFIX in "" "2.6-" ; do  # iterate through the kernel prefixes,
+                                 # currently "" and "2.6-"
+    if package_exists linux-image-${KPREFIX}${KARCH} ; then
+      echo ${KPREFIX}${KARCH}
+      return 0
+    fi
+
+  done
+}
+
+# install kernel packages {{{
+kernel() {
+  $APTUPDATE
+  KVER=$(get_kernel_version)
+  if [ -n "$KVER" ] ; then
      # note: install busybox to be able to debug initramfs
-     KERNELPACKAGES="linux-image-$KERNEL linux-headers-$KERNEL busybox"
+     KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER busybox firmware-linux-free firmware-linux"
      DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
+  else
+     echo "Warning: Could not find a kernel for your system. Your system won't be able to boot itself!"
   fi
 }
 # }}}
@@ -196,9 +327,10 @@ kernel() {
 reconfigure() {
   if [ -n "$RECONFIGURE" ] ; then
      for package in $RECONFIGURE ; do
-         dpkg --list $package 1>/dev/null 2>/dev/null && \
-         DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
-         echo "Warning: $package does not exist, can not reconfigure it."
+         if dpkg --list $package >/dev/null 2>&1 | grep -q '^ii' ; then
+           DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
+           echo "Warning: $package does not exist, can not reconfigure it."
+         fi
      done
   fi
 }
@@ -207,6 +339,11 @@ reconfigure() {
 # set password of user root {{{
 passwords()
 {
+  if [ -n "$NOPASSWORD" ] ; then
+    echo "Skip setting root password as requested."
+    return 0
+  fi
+
   echo "Activating shadow passwords."
   shadowconfig on
 
@@ -215,7 +352,6 @@ passwords()
      CHPASSWD_OPTION='-m'
   fi
 
-
   if [ -n "$ROOTPASSWORD" ] ; then
      echo root:"$ROOTPASSWORD" | chpasswd $CHPASSWD_OPTION
      export ROOTPASSWORD=''
@@ -225,10 +361,14 @@ passwords()
      echo "Setting password for user root:"
      while [ "$a" != "$b" ] ; do
        echo -n "Enter new UNIX password for user root: "
-       read -s a
+       askpass
+       a="$resp"
+       unset resp
        echo
        echo -n "Retype new UNIX password for user root: "
-       read -s b
+       askpass
+       b="$resp"
+       unset resp
        echo
        if [ "$a" != "$b" ] ; then
          echo "Sorry, passwords do not match. Retry."
@@ -288,6 +428,20 @@ EOF
 }
 # }}}
 
+# set default locales {{{
+default_locales() {
+  if [ -n "$DEFAULT_LOCALES" ] ; then
+    if ! [ -x /usr/sbin/update-locale ] ; then
+      echo "Warning: update-locale executable not available (no locales package installed?)"
+      echo "Ignoring request to run update-locale for $DEFAULT_LOCALES therefore"
+      return 0
+    fi
+
+    /usr/sbin/update-locale LANG="$DEFAULT_LOCALES"
+  fi
+}
+# }}}
+
 # adjust timezone {{{
 timezone() {
   if [ -n "$TIMEZONE" ] ; then
@@ -308,7 +462,6 @@ fi
 
 cat >> /etc/fstab << EOF
 proc           /proc        proc    defaults                      0   0
-/sys           /sys         sysfs   noauto,rw,nosuid,nodev,noexec 0   0
 /dev/cdrom     /mnt/cdrom0  iso9660 ro,user,noauto                0   0
 # some other examples:
 # /dev/sda2       none         swap    sw,pri=0             0   0
@@ -374,22 +527,47 @@ initrd() {
 # }}}
 
 # grub configuration/installation {{{
-grub_config() {
+grub_install() {
+
   if [ -z "$GRUB" ] ; then
-     echo "Warning: \$GRUB is not defined, will not adjust grub configuration therefore."
+    echo "Notice: \$GRUB not defined, will not install grub inside chroot at this stage."
+    return 0
+  fi
+
+  if ! dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
+    echo "Notice: grub option set but no grub-pc package, installing it therefore."
+    DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL grub-pc
+  fi
+
+  if ! [ -x "$(which grub-install)" ] ; then
+     echo "Error: grub-install not available. (Error while installing grub package?)" >&2
+     return 1
+  fi
+
+  if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
+     for device in $SELECTED_PARTITIONS ; do
+        GRUB="${device%%[0-9]}"
+        echo "Installing grub on ${GRUB}:"
+        grub-install --no-floppy "$GRUB"
+     done
   else
-     echo "Adjusting grub configuration for use on ${GRUB}."
+     echo "Installing grub on ${GRUB}:"
+     grub-install --no-floppy "$GRUB"
+  fi
 
-     # finally install grub
-     if [ -x /usr/sbin/update-grub ] ; then
-        UPDATEGRUB='/usr/sbin/update-grub'
-     else
-        UPDATEGRUB='/sbin/update-grub'
-     fi
+  echo "Adjusting grub configuration for use on ${GRUB}."
 
-     # grub2:
-     $UPDATEGRUB
+  # finally install grub
+  if [ -x /usr/sbin/update-grub ] ; then
+     UPDATEGRUB='/usr/sbin/update-grub'
+  elif [ -x /sbin/update-grub ] ; then
+     UPDATEGRUB='/sbin/update-grub'
+  else
+    echo "Error: update-grub not available, can not execute it." >&2
+    return 1
   fi
+
+  $UPDATEGRUB
 }
 # }}}
 
@@ -408,29 +586,45 @@ custom_scripts() {
 services() {
   for service in ssh mdadm mdadm-raid ; do
     if [ -x /etc/init.d/"$service" ] ; then
-       /etc/init.d/"$service" stop || /bin/true
+       /etc/init.d/"$service" stop || true
     fi
   done
 }
 # }}}
 
-# unmount all filesystems in chroot, make sure nothing is left {{{
+# unmount /proc and make sure nothing is left {{{
 finalize() {
   # make sure we don't leave any sensible data
   rm -f /etc/debootstrap/variables
+
   [ -n "$POLICYRCD" ] && rm -f /usr/sbin/policy-rc.d
-  umount -a    1>/dev/null 2>/dev/null || true
-  umount /proc 1>/dev/null 2>/dev/null || true
-  umount /proc 1>/dev/null 2>/dev/null || true
-  umount -a    1>/dev/null 2>/dev/null || true
+
+  umount /proc >/dev/null 2>/dev/null || true
 }
 # }}}
 
+# signal handler {{{
+signal_handler() {
+  finalize
+  [ -n "$1" ] && EXIT="$1" || EXIT="1"
+  exit "$EXIT"
+}
+# }}}
+
+# set signal handler {{{
+trap signal_handler HUP INT QUIT TERM
+# }}}
+
 # execute the functions {{{
- for i in chrootmirror grmlrepos kernelimg_conf makedev install_policy_rcd \
-     kernel packages extrapackages reconfigure hosts interfaces   \
-     timezone fstab hostname initrd grub_config passwords custom_scripts   \
-     services ; do
+
+ # always execute install_policy_rcd
+ install_policy_rcd
+
+ for i in chrootmirror grmlrepos backportrepos kernelimg_conf \
+     kernel packages extrapackages  reconfigure hosts interfaces \
+     default_locales timezone fstab hostname initrd grub_install passwords \
+     custom_scripts upgrade_system remove_apt_cache services \
+     remove_chrootmirror; do
      if stage $i ; then
        $i && stage $i done || exit 1
      fi